/* eslint-disable react/forbid-component-props */

/** ** Libraries *** */
import React, { PureComponent } from 'react';
import { DaysRow_propTypes } from './props/propTypes';
/** ** CSS *** */

import style from './DateTime.module.css';
/** ** Components *** */

import { Container, Box } from '../Layout';
export default class DaysRow extends PureComponent {
  render() {
    const {
      dayNames,
      dayNamesShort
    } = this.props;
    return /*#__PURE__*/React.createElement(Container, {
      alignBox: "row",
      align: "center",
      className: style.days
    }, dayNames.map((dayName, index) => /*#__PURE__*/React.createElement(Box, {
      key: dayName,
      className: `${style.daysStr} ${style.grid} ${index === 0 ? style.sunday : ''}`,
      "data-title": dayName,
      "aria-label": dayName
    }, dayNamesShort[index])));
  }

}
DaysRow.propTypes = DaysRow_propTypes;