function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/**** Libraries ****/
import React from 'react';
import { Box } from '../Layout';
import { Icon } from '@zohodesk/icons';
import ListContainer from './ListContainer';
import { ListItemWithIconDefaultProps } from './props/defaultProps';
import { ListItemWithIcon_Props } from './props/propTypes';
/**** CSS ****/

import style from './ListItem.module.css';
export default class ListItemWithIcon extends React.Component {
  constructor(props) {
    super(props);
    this.handleClick = this.handleClick.bind(this);
    this.getRef = this.getRef.bind(this);
    this.handleMouseEnter = this.handleMouseEnter.bind(this);
  }

  getRef(ele) {
    this.ele = ele;
    let {
      index,
      getRef,
      id
    } = this.props;
    getRef && getRef(ele, index, id);
  }

  handleClick(e) {
    let {
      onClick,
      id,
      value,
      index
    } = this.props;
    onClick && onClick(id, value, index, e);
  }

  handleMouseEnter(e) {
    let {
      onMouseEnter,
      id,
      value,
      index
    } = this.props;
    onMouseEnter && onMouseEnter(id, value, index, e);
  }

  render() {
    let {
      size,
      active,
      highlight,
      value,
      iconName,
      iconSize,
      autoHover,
      palette,
      iconClass,
      dataId,
      dataSelectorId,
      title,
      needTick,
      isLink,
      href,
      target,
      needBorder,
      isDisabled,
      disableTitle,
      a11y,
      customClass,
      customProps,
      needMultiLineText
    } = this.props;
    let {
      ListItemProps = {},
      ContainerProps = {}
    } = customProps;
    const listA11y = {
      ariaHidden: true,
      role: 'option',
      ...a11y
    };
    let {
      ariaHidden
    } = listA11y;
    let dataIdString = dataId ? `${dataId.replace("'", '_')}` : value.toLowerCase().replace("'", '_');
    return /*#__PURE__*/React.createElement(ListContainer, _extends({
      a11y: listA11y,
      size: size,
      palette: palette,
      highlight: highlight,
      isDisabled: isDisabled,
      active: active,
      autoHover: autoHover,
      needTick: needTick,
      needBorder: needBorder,
      customClass: customClass,
      dataId: dataIdString,
      dataSelectorId: dataSelectorId,
      isLink: isLink,
      href: href,
      target: target,
      onClick: this.handleClick,
      onMouseOver: this.handleMouseEnter,
      eleRef: this.getRef,
      disableTitle: disableTitle,
      title: null,
      customProps: ListItemProps
    }, ContainerProps), iconName && /*#__PURE__*/React.createElement(Box, {
      "aria-hidden": true,
      className: style.iconBox,
      dataId: dataId ? `${dataId}_Icon` : `${value.toLowerCase().replace("'", '_')}_Icon`
    }, /*#__PURE__*/React.createElement(Icon, {
      iconClass: iconClass,
      name: iconName,
      size: iconSize
    })), iconClass && !iconName ? /*#__PURE__*/React.createElement("span", {
      className: iconClass
    }) : null, value && /*#__PURE__*/React.createElement(Box, {
      flexible: true,
      shrink: true,
      className: needMultiLineText ? style.multiLineValue : style.value,
      "data-title": isDisabled ? null : title,
      dataId: `${dataIdString}_Text`
    }, value), needTick && active ? /*#__PURE__*/React.createElement(Box, {
      className: style.tickIcon,
      "aria-hidden": ariaHidden,
      dataId: `${dataIdString}_tickIcon`,
      dataSelectorId: `${dataSelectorId}_tickIcon`
    }, /*#__PURE__*/React.createElement(Icon, {
      name: "ZD-ticknew",
      size: "8"
    })) : null);
  }

}
ListItemWithIcon.defaultProps = ListItemWithIconDefaultProps;
ListItemWithIcon.propTypes = ListItemWithIcon_Props; // if (__DOCS__) {
//   ListItemWithIcon.docs = {
//     componentGroup: 'Molecule',
//     folderName: 'Style Guide'
//   };
// }