import React, { useState, useEffect } from 'react';
import PropTypes from 'prop-types';
import LibraryContextInit from './LibraryContextInit';
import { getLibraryConfig } from './Config';

const LibraryContextProvider = _ref => {
  let {
    isReducedMotion = getLibraryConfig('isReducedMotion'),
    direction = getLibraryConfig('direction'),
    children
  } = _ref;
  const [value, setValue] = useState({
    isReducedMotion,
    direction
  });

  function setGlobalContext(key, data) {
    if (value[key] != data) {
      setValue({ ...value,
        [key]: data
      });
    }
  }

  return /*#__PURE__*/React.createElement(LibraryContextInit.Provider, {
    value: { ...value,
      setGlobalContext
    }
  }, children);
};

LibraryContextProvider.propTypes = {
  children: PropTypes.node.isRequired,
  isReducedMotion: PropTypes.bool,
  direction: PropTypes.string
};
export default LibraryContextProvider;