function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useState, useCallback } from 'react';
import { TabWrapper_defaultProps } from './props/defaultProps';
import { TabWrapper_propTypes } from './props/propTypes';
import { Container } from '../Layout';

function TabWrapper(_ref) {
  let {
    defaultTab,
    hookToDisableInternalState,
    onSelect,
    type,
    isAnimate,
    needTabBorder,
    needBorder,
    needPadding,
    needAppearance,
    align,
    dataId,
    children,
    dataSelectorId
  } = _ref;
  let [selectedTabInternal, setSelected] = useState(!hookToDisableInternalState ? defaultTab || 0 : null);
  const setSelectedTab = useCallback(id => {
    if (!hookToDisableInternalState) {
      setSelected(id);
    }

    onSelect && onSelect(id);
  }, [hookToDisableInternalState, onSelect]);
  return /*#__PURE__*/React.createElement(Container, {
    alignBox: align === 'vertical' ? 'column' : 'row',
    dataId: dataId,
    dataSelectorId: dataSelectorId
  }, React.Children.map(children, child => {
    let TabsChild = child.type;
    let selectedTab = hookToDisableInternalState ? defaultTab : selectedTabInternal;
    return /*#__PURE__*/React.createElement(TabsChild // eslint-disable-next-line react/no-array-index-key
    , _extends({}, child.props, {
      selectedTab: selectedTab,
      onSelect: setSelectedTab,
      type: type,
      isAnimate: isAnimate,
      needTabBorder: needTabBorder,
      needBorder: needBorder,
      needPadding: needPadding,
      needAppearance: needAppearance,
      hookToDisableInternalState: hookToDisableInternalState,
      align: align
    }));
  }));
}

TabWrapper.propTypes = TabWrapper_propTypes;
TabWrapper.defaultProps = TabWrapper_defaultProps;
export default TabWrapper;