import PropTypes from 'prop-types';
export const Tab_propTypes = {
  activeClass: PropTypes.string,
  align: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.element, PropTypes.string]),
  className: PropTypes.string,
  dataId: PropTypes.string,
  getTabRef: PropTypes.func,
  href: PropTypes.string,
  id: PropTypes.string,
  isActive: PropTypes.bool,
  isAnimate: PropTypes.bool,
  isDisabled: PropTypes.bool,
  isLink: PropTypes.bool,
  needAppearance: PropTypes.bool,
  needBorder: PropTypes.bool,
  onClick: PropTypes.func,
  onSelect: PropTypes.func,
  style: PropTypes.object,
  text: PropTypes.string,
  title: PropTypes.string,
  titlePosition: PropTypes.oneOf(['top', 'bottom', 'right', 'left']),
  tourId: PropTypes.string,
  type: PropTypes.string,
  customProps: PropTypes.object,
  isVirtual: PropTypes.bool,
  dataSelectorId: PropTypes.string
};
export const TabContent_propTypes = {
  children: PropTypes.node,
  dataId: PropTypes.string,
  id: PropTypes.string,
  scroll: PropTypes.oneOf(['vertical', 'horizontal', 'both', 'none']),
  dataSelectorId: PropTypes.string
};
export const TabContentWrapper_propTypes = {
  children: PropTypes.node,
  className: PropTypes.string,
  dataId: PropTypes.string,
  onScroll: PropTypes.func,
  selectedTab: PropTypes.string,
  style: PropTypes.object,
  dataSelectorId: PropTypes.string
};
export const Tabs_propTypes = {
  align: PropTypes.oneOf(['vertical', 'horizontal']),
  boxPosition: PropTypes.string,
  childType: PropTypes.elementType,
  children: PropTypes.array,
  className: PropTypes.string,
  dataId: PropTypes.string,
  getContainerRef: PropTypes.func,
  highlightClass: PropTypes.string,
  iconName: PropTypes.string,
  iconSize: PropTypes.string,
  isAnimate: PropTypes.bool,
  isPopupOpen: PropTypes.bool,
  isPopupReady: PropTypes.bool,
  isResponsive: PropTypes.bool,
  itemActiveClass: PropTypes.string,
  itemClass: PropTypes.string,
  maxTabsCount: PropTypes.number,
  menuItemClass: PropTypes.string,
  minTabsCount: PropTypes.number,
  moreBoxClass: PropTypes.string,
  moreButtonActiveClass: PropTypes.string,
  moreButtonClass: PropTypes.string,
  moreContainerClass: PropTypes.string,
  needAppearance: PropTypes.bool,
  needBorder: PropTypes.bool,
  needPadding: PropTypes.bool,
  needTabBorder: PropTypes.bool,
  onScroll: PropTypes.func,
  onSelect: PropTypes.func,
  position: PropTypes.string,
  removeClose: PropTypes.func,
  selectedTab: PropTypes.string,
  showTitleInMoreOptions: PropTypes.bool,
  style: PropTypes.object,
  togglePopup: PropTypes.func,
  type: PropTypes.oneOf(['alpha', 'beta', 'delta']),
  getTargetRef: PropTypes.func,
  containerClass: PropTypes.string,
  customProps: PropTypes.shape({
    DropBoxProps: PropTypes.object,
    ListItemProps: PropTypes.object,
    MoreButtonProps: PropTypes.object
  }),
  getCustomDropBoxHeaderPlaceHolder: PropTypes.func,
  dataSelectorId: PropTypes.string
};
export const TabWrapper_propTypes = {
  align: PropTypes.oneOf(['vertical', 'horizontal']),
  children: PropTypes.node,
  dataId: PropTypes.string,
  defaultTab: PropTypes.string,
  hookToDisableInternalState: PropTypes.bool,
  isAnimate: PropTypes.bool,
  needAppearance: PropTypes.bool,
  needBorder: PropTypes.bool,
  needPadding: PropTypes.bool,
  needTabBorder: PropTypes.bool,
  onSelect: PropTypes.func,
  type: PropTypes.oneOf(['alpha', 'beta', 'delta']),
  dataSelectorId: PropTypes.string
};