function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { defaultProps } from '../../AvatarTeam/props/defaultProps';
import { propTypes } from '../../AvatarTeam/props/propTypes';
import Avatar from '../Avatar/Avatar';
import style from '../../AvatarTeam/AvatarTeam.module.css';
/* once avatar support firstname lastname and pattern
pass lastName as team name and pattern ["FIRST_NAME","LAST_NAME"] as props

Not going to export to external then can kept inside supportapp
*/

export default function AvatarTeam(props) {
  const {
    src,
    name,
    size,
    palette,
    textPalette,
    onClick,
    title,
    isFilled,
    dataId,
    needTitle,
    customClass,
    borderOnActive,
    borderOnHover,
    dataSelectorId,
    customProps,
    needInnerBorder,
    needBorder,
    needDefaultBorder
  } = props;
  const {
    AvatarTeamProps = {},
    AvatarProps = {}
  } = customProps;
  const {
    customAvatar = '',
    customAvatarTeam = ''
  } = customClass;
  const border = borderOnHover || onClick;
  return /*#__PURE__*/React.createElement("span", _extends({
    className: `${style.container} ${borderOnActive ? style.borderOnActive : border ? style.borderOnHover : ''} `,
    "data-id": dataId,
    "data-test-id": dataId,
    "data-selector-id": dataSelectorId
  }, AvatarTeamProps), /*#__PURE__*/React.createElement(Avatar, _extends({
    name: name,
    onClick: onClick,
    palette: palette,
    textPalette: textPalette,
    size: size,
    src: src,
    title: title,
    needTitle: needTitle,
    customClass: customAvatar,
    borderOnActive: borderOnActive,
    borderOnHover: border,
    needInnerBorder: needInnerBorder,
    needBorder: needBorder,
    needDefaultBorder: needDefaultBorder
  }, AvatarProps)), /*#__PURE__*/React.createElement("span", {
    className: `${style.team} ${isFilled ? `${style[`${palette}Filled`]}` : style.nofill} 
          ${style[`${size}team`]} ${customAvatarTeam}`
  }));
}
AvatarTeam.defaultProps = defaultProps;
AvatarTeam.propTypes = propTypes;