/* eslint-disable react/forbid-component-props */

/** ** Libraries *** */
import React, { PureComponent } from 'react';
import { DateTimePopupFooter_propTypes } from './props/propTypes';
import { DateTimePopupFooter_defaultProps } from './props/defaultProps';
/** ** Components *** */

import { Container } from '../Layout';
import Button from '../Button/Button';
/** ** CSS *** */

import style from '../../DateTime/DateTime.module.css';
export default class DateTimePopupFooter extends PureComponent {
  render() {
    const {
      submitText,
      onSubmit,
      cancelText,
      onCancel,
      dataId
    } = this.props;
    return /*#__PURE__*/React.createElement(Container, {
      isCover: false,
      align: "vertical",
      alignBox: "row",
      className: style.footer
    }, /*#__PURE__*/React.createElement(Button, {
      text: submitText,
      size: "medium",
      palette: "primaryFilled",
      onClick: onSubmit,
      dataId: `${dataId}_saveBtn`
    }), /*#__PURE__*/React.createElement("span", {
      className: style.space
    }), /*#__PURE__*/React.createElement(Button, {
      text: cancelText,
      size: "medium",
      palette: "secondary",
      onClick: onCancel,
      dataId: `${dataId}_clearBtn`
    }));
  }

}
DateTimePopupFooter.propTypes = DateTimePopupFooter_propTypes;
DateTimePopupFooter.defaultProps = DateTimePopupFooter_defaultProps;