import React from 'react';
import { defaultProps } from '../../Heading/props/defaultProps';
import { propTypes } from '../../Heading/props/propTypes';
import style from '../../Heading/Heading.module.css';
export default function Heading(props) {
  let {
    tagName,
    className,
    onClick,
    onDoubleClick,
    title,
    dataTitle,
    dataId,
    a11y
  } = props;
  return /*#__PURE__*/React.createElement(tagName, {
    className: `${style.reset} ${className}`,
    onClick,
    onDoubleClick,
    'data-title': dataTitle || title,
    'data-id': dataId,
    'data-test-id': dataId,
    ...a11y
  }, title);
}
Heading.propTypes = propTypes;
Heading.defaultProps = defaultProps; // if (__DOCS__) {
//   Heading.docs = {
//     folderName: 'Style Guide',
//     componentGroup: 'Accessibility'
//   };
// }