import React, { memo } from 'react';
import { defaultProps } from '../../Stencils/props/defaultProps';
import { propTypes } from '../../Stencils/props/propTypes';
import style from '../../Stencils/Stencils.module.css';

function Stencils(props) {
  let {
    shape,
    size,
    palette,
    customClass
  } = props;
  size = shape === 'rect' ? style[size] : style[`c${size}`];
  shape = shape === 'rect' ? style.rectangular : style.circle;
  return /*#__PURE__*/React.createElement("div", {
    className: `${style.container} ${shape} ${size} ${style[palette]} ${customClass}`
  });
}

Stencils.propTypes = propTypes;
Stencils.defaultProps = defaultProps;
const MemoizedStencils = /*#__PURE__*/memo(Stencils);
MemoizedStencils.propTypes = propTypes;
MemoizedStencils.defaultProps = defaultProps;
MemoizedStencils.displayName = 'Stencils';
export default MemoizedStencils;