"use strict";

var _react = _interopRequireDefault(require("react"));

var _Button = _interopRequireDefault(require("../Button"));

var _react2 = require("@testing-library/react");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('Button component', function () {
  test('Should be render with the basic set of default props', function () {
    var _render = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], null)),
        asFragment = _render.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var palette = ['plainPrimary', 'plainSecondary', 'primary', 'primaryFilled', 'dangerFilled', 'secondary', 'secondaryFilled', 'successFilled', 'info', 'tertiaryFilled'];
  test.each(palette)('Should render palette of buttons - %s', function (palette) {
    var _render2 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      palette: palette
    })),
        asFragment = _render2.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var size = ['small', 'medium', 'large', 'xlarge'];
  test.each(size)('Should render Sizes of buttons - %s', function (size) {
    var _render3 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      size: size
    })),
        asFragment = _render3.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var status = ['loading', 'success', 'none'];
  test.each(status)('Should render Status of buttons - %s', function (status) {
    var _render4 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      status: status
    })),
        asFragment = _render4.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var customStatus = ['loading', 'success'];
  test.each(customStatus)('Should render CustomStatusclassname of buttons - %s', function (customStatus) {
    var _render5 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      status: customStatus,
      customClass: {
        customStatus: "customStautusClassName"
      }
    })),
        asFragment = _render5.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render with the basic set of default props with disabled is true', function () {
    var _render6 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      disabled: true
    })),
        asFragment = _render6.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render with the basic set of default props with isBold is false', function () {
    var _render7 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      isBold: false
    })),
        asFragment = _render7.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render with the basic set of default props with rounded is true', function () {
    var _render8 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      rounded: true
    })),
        asFragment = _render8.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render with the basic set of default props with needAppearance is false', function () {
    var _render9 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      needAppearance: false
    })),
        asFragment = _render9.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render with the basic set customButtonclass with buttonClass ', function () {
    var _render10 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      customClass: {
        customButton: "customButtonClass"
      }
    })),
        asFragment = _render10.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render with the basic set customstatusSize props with buttonClass ', function () {
    var _render11 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      customClass: {
        customStatusSize: "customButtonClass"
      }
    })),
        asFragment = _render11.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render with the basic set customstyle ', function () {
    var _render12 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      customStyle: {
        bold: "buttonBold"
      }
    })),
        asFragment = _render12.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render with the customstyle with medium ', function () {
    var _render13 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      customStyle: {
        $medium: "buttonMedium"
      }
    })),
        asFragment = _render13.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
});