"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ContainerProps = exports.BoxProps = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var BoxProps = {
  adjust: _propTypes["default"].bool,
  align: _propTypes["default"].oneOf(['start', 'end', 'center']),
  children: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].string]),
  className: _propTypes["default"].string,
  column: _propTypes["default"].oneOf(['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12']),
  dataId: _propTypes["default"].string,
  testId: _propTypes["default"].string,
  dataSelectorId: _propTypes["default"].string,
  eleRef: _propTypes["default"].func,
  flexible: _propTypes["default"].bool,
  hidden: _propTypes["default"].arrayOf(function (propValue, key, componentName, location, propFullName) {
    if (['xs', 'sm', 'md', 'lg', 'xl'].indexOf(propValue[key]) === -1) {
      return new Error("Invalid prop `".concat(propFullName, "` supplied to") + " `".concat(componentName, "`. Validation failed."));
    }
  }),
  isFirst: _propTypes["default"].bool,
  isLast: _propTypes["default"].bool,
  isScrollAttribute: _propTypes["default"].bool,
  scroll: _propTypes["default"].oneOf(['vertical', 'horizontal', 'both', 'none']),
  shrink: _propTypes["default"].bool,
  tagName: _propTypes["default"].string,
  tourId: _propTypes["default"].string,
  preventParentScroll: _propTypes["default"].oneOf(['vertical', 'horizontal', 'both'])
};
exports.BoxProps = BoxProps;
var ContainerProps = {
  align: _propTypes["default"].oneOf(['vertical', 'horizontal', 'both', 'top', 'right', 'bottom', 'left', 'between', 'around', 'baseline']),
  alignBox: _propTypes["default"].oneOf(['row', 'column', 'row-reverse', 'column-reverse']),
  alignContent: _propTypes["default"].oneOf(['start', 'end', 'center', 'around', 'between']),
  children: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].string]),
  className: _propTypes["default"].string,
  dataId: _propTypes["default"].string,
  testId: _propTypes["default"].string,
  dataSelectorId: _propTypes["default"].string,
  eleRef: _propTypes["default"].func,
  hidden: _propTypes["default"].array,
  isCover: _propTypes["default"].bool,
  isInline: _propTypes["default"].bool,
  isScrollAttribute: _propTypes["default"].bool,
  scroll: _propTypes["default"].oneOf(['vertical', 'horizontal', 'both', 'none']),
  tagName: _propTypes["default"].string,
  tourId: _propTypes["default"].string,
  wrap: _propTypes["default"].oneOf(['wrap', 'wrap-reverse', 'nowrap']),
  preventParentScroll: _propTypes["default"].oneOf(['vertical', 'horizontal', 'both'])
};
exports.ContainerProps = ContainerProps;