"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ListItem_Props = exports.ListItemWithRadio_Props = exports.ListItemWithIcon_Props = exports.ListItemWithCheckBox_Props = exports.ListItemWithAvatar_Props = exports.ListContainer_Props = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ListItemWithAvatar_P;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ListContainer_Props = {
  active: _propTypes["default"].bool,
  autoHover: _propTypes["default"].bool,
  children: _propTypes["default"].node,
  dataId: _propTypes["default"].string,
  dataSelectorId: _propTypes["default"].string,
  disableTitle: _propTypes["default"].string,
  highlight: _propTypes["default"].bool,
  href: _propTypes["default"].string,
  isDisabled: _propTypes["default"].bool,
  isLink: _propTypes["default"].bool,
  needBorder: _propTypes["default"].bool,
  needTick: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  palette: _propTypes["default"].oneOf(['default', 'primary', 'secondary', 'dark']),
  size: _propTypes["default"].oneOf(['small', 'medium', 'large']),
  target: _propTypes["default"].oneOf(['blank', 'self']),
  title: _propTypes["default"].string,
  a11y: _propTypes["default"].shape({
    role: _propTypes["default"].string,
    ariaSelected: _propTypes["default"].bool
  }),
  customClass: _propTypes["default"].string,
  customProps: _propTypes["default"].object,
  eleRef: _propTypes["default"].func
};
exports.ListContainer_Props = ListContainer_Props;
var ListItem_Props = {
  active: _propTypes["default"].bool,
  autoHover: _propTypes["default"].bool,
  children: _propTypes["default"].node,
  dataId: _propTypes["default"].string,
  dataSelectorId: _propTypes["default"].string,
  disableTitle: _propTypes["default"].string,
  getRef: _propTypes["default"].func,
  highlight: _propTypes["default"].bool,
  href: _propTypes["default"].string,
  id: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  index: _propTypes["default"].number,
  isDisabled: _propTypes["default"].bool,
  isLink: _propTypes["default"].bool,
  needBorder: _propTypes["default"].bool,
  needTick: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  palette: _propTypes["default"].oneOf(['default', 'primary', 'secondary', 'dark']),
  size: _propTypes["default"].oneOf(['small', 'medium', 'large']),
  target: _propTypes["default"].oneOf(['blank', 'self']),
  title: _propTypes["default"].string,
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]).isRequired,
  a11y: _propTypes["default"].shape({
    role: _propTypes["default"].string,
    ariaSelected: _propTypes["default"].bool
  }),
  needMultiLineText: _propTypes["default"].bool,
  customClass: _propTypes["default"].shape({
    customListItem: _propTypes["default"].string,
    customTickIcon: _propTypes["default"].string
  }),
  customProps: _propTypes["default"].shape({
    ListItemProps: _propTypes["default"].object
  })
};
exports.ListItem_Props = ListItem_Props;
var ListItemWithAvatar_Props = (_ListItemWithAvatar_P = {
  active: _propTypes["default"].bool,
  autoHover: _propTypes["default"].bool,
  avatarPalette: _propTypes["default"].string
}, _defineProperty(_ListItemWithAvatar_P, "avatarPalette", _propTypes["default"].string), _defineProperty(_ListItemWithAvatar_P, "dataId", _propTypes["default"].string), _defineProperty(_ListItemWithAvatar_P, "dataSelectorId", _propTypes["default"].string), _defineProperty(_ListItemWithAvatar_P, "disableTitle", _propTypes["default"].string), _defineProperty(_ListItemWithAvatar_P, "getRef", _propTypes["default"].func), _defineProperty(_ListItemWithAvatar_P, "highlight", _propTypes["default"].bool), _defineProperty(_ListItemWithAvatar_P, "id", _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number])), _defineProperty(_ListItemWithAvatar_P, "imgSrc", _propTypes["default"].string), _defineProperty(_ListItemWithAvatar_P, "index", _propTypes["default"].number), _defineProperty(_ListItemWithAvatar_P, "initial", _propTypes["default"].string), _defineProperty(_ListItemWithAvatar_P, "isDisabled", _propTypes["default"].bool), _defineProperty(_ListItemWithAvatar_P, "isTeam", _propTypes["default"].bool), _defineProperty(_ListItemWithAvatar_P, "name", _propTypes["default"].string), _defineProperty(_ListItemWithAvatar_P, "needAvatarTitle", _propTypes["default"].bool), _defineProperty(_ListItemWithAvatar_P, "needBorder", _propTypes["default"].bool), _defineProperty(_ListItemWithAvatar_P, "needTick", _propTypes["default"].bool), _defineProperty(_ListItemWithAvatar_P, "onClick", _propTypes["default"].func), _defineProperty(_ListItemWithAvatar_P, "onMouseEnter", _propTypes["default"].func), _defineProperty(_ListItemWithAvatar_P, "palette", _propTypes["default"].oneOf(['dark'])), _defineProperty(_ListItemWithAvatar_P, "size", _propTypes["default"].string), _defineProperty(_ListItemWithAvatar_P, "title", _propTypes["default"].string), _defineProperty(_ListItemWithAvatar_P, "value", _propTypes["default"].string), _defineProperty(_ListItemWithAvatar_P, "a11y", _propTypes["default"].shape({
  role: _propTypes["default"].string,
  ariaSelected: _propTypes["default"].bool,
  ariaHidden: _propTypes["default"].bool
})), _defineProperty(_ListItemWithAvatar_P, "customClass", _propTypes["default"].shape({
  customListItem: _propTypes["default"].string,
  customAvatar: _propTypes["default"].string,
  customAvatarTeam: _propTypes["default"].string
})), _defineProperty(_ListItemWithAvatar_P, "needMultiLineText", _propTypes["default"].bool), _defineProperty(_ListItemWithAvatar_P, "customProps", _propTypes["default"].shape({
  ListItemProps: _propTypes["default"].object
})), _ListItemWithAvatar_P);
exports.ListItemWithAvatar_Props = ListItemWithAvatar_Props;
var ListItemWithCheckBox_Props = {
  active: _propTypes["default"].bool,
  autoHover: _propTypes["default"].bool,
  checked: _propTypes["default"].bool,
  dataId: _propTypes["default"].string,
  dataSelectorId: _propTypes["default"].string,
  disableTitle: _propTypes["default"].string,
  getRef: _propTypes["default"].func,
  highlight: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  index: _propTypes["default"].string,
  isDisabled: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  onHover: _propTypes["default"].func,
  palette: _propTypes["default"].string,
  size: _propTypes["default"].string,
  title: _propTypes["default"].string,
  value: _propTypes["default"].string,
  a11y: _propTypes["default"].shape({
    role: _propTypes["default"].string,
    ariaSelected: _propTypes["default"].bool
  }),
  needMultiLineText: _propTypes["default"].bool,
  customClass: _propTypes["default"].shape({
    customListItem: _propTypes["default"].string,
    customCheckBox: _propTypes["default"].string,
    customLabel: _propTypes["default"].string
  }),
  customProps: _propTypes["default"].object
};
exports.ListItemWithCheckBox_Props = ListItemWithCheckBox_Props;
var ListItemWithIcon_Props = {
  active: _propTypes["default"].bool,
  autoHover: _propTypes["default"].bool,
  dataId: _propTypes["default"].string,
  dataSelectorId: _propTypes["default"].string,
  disableTitle: _propTypes["default"].string,
  getRef: _propTypes["default"].func,
  highlight: _propTypes["default"].bool,
  iconClass: _propTypes["default"].string,
  iconName: _propTypes["default"].string,
  iconSize: _propTypes["default"].string,
  id: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  index: _propTypes["default"].number,
  isDisabled: _propTypes["default"].bool,
  needBorder: _propTypes["default"].bool,
  needTick: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  palette: _propTypes["default"].string,
  size: _propTypes["default"].string,
  title: _propTypes["default"].string,
  value: _propTypes["default"].string,
  a11y: _propTypes["default"].shape({
    role: _propTypes["default"].string,
    ariaSelected: _propTypes["default"].bool,
    ariaHidden: _propTypes["default"].bool
  }),
  needMultiLineText: _propTypes["default"].bool,
  customClass: _propTypes["default"].string,
  customProps: _propTypes["default"].shape({
    ListItemProps: _propTypes["default"].object
  }),
  isLink: _propTypes["default"].bool,
  href: _propTypes["default"].string,
  target: _propTypes["default"].string
};
exports.ListItemWithIcon_Props = ListItemWithIcon_Props;
var ListItemWithRadio_Props = {
  active: _propTypes["default"].bool,
  autoHover: _propTypes["default"].bool,
  checked: _propTypes["default"].bool,
  dataId: _propTypes["default"].string,
  dataSelectorId: _propTypes["default"].string,
  disableTitle: _propTypes["default"].string,
  getRef: _propTypes["default"].func,
  highlight: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  index: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  isDisabled: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  onHover: _propTypes["default"].func,
  palette: _propTypes["default"].string,
  size: _propTypes["default"].string,
  title: _propTypes["default"].string,
  value: _propTypes["default"].string,
  a11y: _propTypes["default"].shape({
    role: _propTypes["default"].string,
    ariaSelected: _propTypes["default"].bool
  }),
  needMultiLineText: _propTypes["default"].bool,
  customClass: _propTypes["default"].shape({
    customListItem: _propTypes["default"].string,
    customRadio: _propTypes["default"].string,
    customRadioWrap: _propTypes["default"].string
  }),
  customProps: _propTypes["default"].object
};
exports.ListItemWithRadio_Props = ListItemWithRadio_Props;