"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getZIndex = getZIndex;
exports.removeGlobalZIndexPrefix = removeGlobalZIndexPrefix;
exports.setInitialZIndex = setInitialZIndex;
exports.useZIndex = useZIndex;

var _NumberGenerator = require("./NumberGenerator/NumberGenerator");

var _Config = require("./Config");

var globalId = (0, _Config.getLibraryConfig)('zindexCounter'),
    deletedIndexes = [],
    globalPrefix;

function removeGlobalZIndexPrefix() {
  globalPrefix = undefined;
}

function getGlobalZIndexPrefix() {
  return globalPrefix;
}

function setInitialZIndex(id) {
  globalId = id;
}

function getGlobalId() {
  return globalId;
}

function setDeletedIndexes(array) {
  deletedIndexes = array;
}

function getDeletedIndexes() {
  return deletedIndexes;
}

function callback(_ref) {
  var globalId = _ref.globalId,
      deletedIndexes = _ref.deletedIndexes;
  setInitialZIndex(globalId);
  setDeletedIndexes(deletedIndexes);
}

function useZIndex(prefix) {
  return (0, _NumberGenerator.useNumberGenerator)({
    getGlobalId: getGlobalId,
    prefix: prefix,
    getGlobalPrefix: getGlobalZIndexPrefix,
    getDeletedIndexes: getDeletedIndexes,
    callback: callback
  });
}

function getZIndex(Component, prefix) {
  return (0, _NumberGenerator.getNumberGenerators)({
    Component: Component,
    prefix: prefix,
    getGlobalPrefix: getGlobalZIndexPrefix,
    getGlobalId: getGlobalId,
    getDeletedIndexes: getDeletedIndexes,
    callback: callback
  });
}