"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ResponsiveContext = void 0;
exports.ResponsiveReceiver = ResponsiveReceiver;
exports.ResponsiveSender = void 0;
exports.useResponsiveReceiver = useResponsiveReceiver;

var _react = _interopRequireWildcard(require("react"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

var _ResizeObserver = _interopRequireDefault(require("./ResizeObserver"));

var _RefWrapper = _interopRequireDefault(require("./RefWrapper"));

var _windowResizeObserver = require("./windowResizeObserver");

var _utils = require("./utils/");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

// const sortedBreackPointKey = [  'MOBILE_XS',  'MOBILE_S',  'MOBILE_M',  'MOBILE',  'TABLET_S',  'TABLET_M',  'TABLET',  'LAPTOP_S',  'LAPTOP_M',  'LAPTOP',  'MONITOR_M',  'MONITOR'];
var ResponsiveContext = /*#__PURE__*/_react["default"].createContext({});

exports.ResponsiveContext = ResponsiveContext;
var defaultResponsiveId = 'parentReceiver';

var ResponsiveSender = /*#__PURE__*/function (_React$Component) {
  _inherits(ResponsiveSender, _React$Component);

  var _super = _createSuper(ResponsiveSender);

  function ResponsiveSender(props) {
    var _this;

    _classCallCheck(this, ResponsiveSender);

    _this = _super.call(this, props); // method binding

    _this.onResize = _this.onResize.bind(_assertThisInitialized(_this));
    _this.containerRef = _this.containerRef.bind(_assertThisInitialized(_this));
    _this.getWidth = _this.getWidth.bind(_assertThisInitialized(_this));
    _this.state = {
      breakPoint: null,
      getWidth: _this.getWidth
    }; // variables

    _this.observer = new _ResizeObserver["default"](_this.onResize);
    _this.size = null;
    return _this;
  }

  _createClass(ResponsiveSender, [{
    key: "getWidth",
    value: function getWidth() {
      if (!this.size) {
        return 0;
      }

      var width = this.size.width;
      return width;
    }
  }, {
    key: "onResize",
    value: function onResize(size) {
      // const { matcher } = this.props;
      var breakPoint = this.state.breakPoint;
      var newBreakPoint = (0, _utils.defaultMatcher)(size);
      this.size = size;

      if (breakPoint !== newBreakPoint) {
        this.setState({
          breakPoint: newBreakPoint
        });
      }
    }
  }, {
    key: "containerRef",
    value: function containerRef(node) {
      this.observer.replaceObservationElement(node);
    }
  }, {
    key: "isChanged",
    value: function isChanged(data, key) {
      this.memo = this.memo || {};
      var changed = this.memo[key] !== data;
      this.memo[key] = data;
      return changed;
    }
  }, {
    key: "render",
    value: function render() {
      var parentContext = this.context;
      var _this$props = this.props,
          children = _this$props.children,
          domRefKey = _this$props.domRefKey,
          responsiveId = _this$props.responsiveId;
      var childContext = this.childContext; // NOTE: this method called here ,Because of we must update local memo.

      var isStateChanged = this.isChanged(this.state, 'state');

      if (this.isChanged(this.context, 'context') || isStateChanged) {
        childContext = Object.assign({}, parentContext);
        childContext[responsiveId] = this.state;
        childContext[defaultResponsiveId] = this.state; // NOTE: this for fallback of if responsive receiver id wrong
      }

      this.childContext = childContext;
      return /*#__PURE__*/_react["default"].createElement(ResponsiveContext.Provider, {
        value: childContext
      }, /*#__PURE__*/_react["default"].createElement(_RefWrapper["default"], {
        domRefKey: domRefKey,
        ref: this.containerRef
      }, children));
    }
  }]);

  return ResponsiveSender;
}(_react["default"].Component);

exports.ResponsiveSender = ResponsiveSender;
ResponsiveSender.defaultProps = _objectSpread(_objectSpread({}, _defaultProps.ResponsiveSender_defaultProps), {}, {
  responsiveId: defaultResponsiveId
});
ResponsiveSender.contextType = ResponsiveContext;
ResponsiveSender.propTypes = _propTypes.ResponsiveSender_propTypes;

function useResponsiveReceiver() {
  var responsiveId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultResponsiveId;

  var _useState = (0, _react.useState)(),
      _useState2 = _slicedToArray(_useState, 2),
      _ = _useState2[0],
      forceUpdate = _useState2[1];

  var totalContextData = (0, _react.useContext)(ResponsiveContext);
  var contextData = totalContextData[responsiveId] || totalContextData[defaultResponsiveId]; // NOTE: this for fallback of if responsive receiver id wrong

  var data = contextData;
  (0, _react.useEffect)(function () {
    !contextData && _windowResizeObserver.windowResizeObserver.observe(forceUpdate);
    return function () {
      return !contextData && _windowResizeObserver.windowResizeObserver.unobserve(forceUpdate);
    };
  }, [!!contextData]);

  if (!contextData) {
    data = {
      breakPoint: _windowResizeObserver.windowResizeObserver.getBreackPoint(),
      getWidth: function getWidth() {
        return _windowResizeObserver.windowResizeObserver.getSize().width;
      }
    };
  }

  var _data = data,
      breakPoint = _data.breakPoint,
      getWidth = _data.getWidth;
  var childArg = (0, _react.useMemo)(function () {
    var isTouchDevice = 'ontouchstart' in window && navigator.userAgent.match(/mobi/i) ? true : false;
    return {
      breakPoint: breakPoint,
      isTouchDevice: isTouchDevice,
      deviceBetween: function deviceBetween(breakPoint1, breakPoint2) {
        var width = getWidth();

        if (!width) {
          return false;
        } // const smallBreakPointIndex = sortedBreackPointKey.indexOf(breakPoint1);
        // const value1 = smallBreakPointIndex < 1 ?  0 : getBreakPointValue(sortedBreackPointKey[smallBreakPointIndex-1]);


        var value1 = (0, _utils.getBreakPointValue)(breakPoint1);
        var value2 = (0, _utils.getBreakPointValue)(breakPoint2);

        if (value1 > value2) {
          return this.deviceBetween(breakPoint2, breakPoint1);
        }

        return value1 <= width && value2 >= width || breakPoint1 === breakPoint || breakPoint2 === breakPoint;
      },
      deviceOnly: function deviceOnly() {
        var breakPoints = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        return breakPoints.includes(breakPoint);
      },
      deviceUpto: function deviceUpto(breakPoint) {
        var width = getWidth();

        if (!width) {
          return false;
        }

        return width <= (0, _utils.getBreakPointValue)(breakPoint);
      }
    };
  }, [breakPoint, getWidth]);
  return childArg;
} // function ResponsiveReceiverFunc({ children, hiddenSizes }, ref) {
//   const { breakPoint, methods } = useResponsiveReceiver();
//   console.log(hiddenSizes);
//   return hiddenSizes.indexOf(breakPoint) === -1 ? (
//     <RefWrapper ref={ref}>{children(breakPoint, methods)}</RefWrapper>
//   ) : null;
// }


function ResponsiveReceiver(_ref) {
  var children = _ref.children,
      responsiveId = _ref.responsiveId,
      hiddenSizes = _ref.hiddenSizes,
      eleRef = _ref.eleRef,
      domRefKey = _ref.domRefKey;
  var data = useResponsiveReceiver(responsiveId);
  var breakPoint = data.breakPoint;
  var child = children(data);
  return !hiddenSizes.includes(breakPoint) ? eleRef ? /*#__PURE__*/_react["default"].createElement(_RefWrapper["default"], {
    domRefKey: domRefKey,
    ref: eleRef
  }, child) : child : null;
}

ResponsiveReceiver.defaultProps = _objectSpread(_objectSpread({}, _defaultProps.ResponsiveReceiver_defaultProps), {}, {
  responsiveId: defaultResponsiveId
});
ResponsiveReceiver.propTypes = _propTypes.ResponsiveReceiver_propTypes;