"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.breakPoints = void 0;
exports.defaultMatcher = defaultMatcher;
exports.getBreakPointValue = getBreakPointValue;
exports.sortedBreackPointKey = void 0;

var _getHTMLFontSize = require("../../utils/getHTMLFontSize");

var breakPoints = {
  // common break points
  MOBILE: 30,
  //480
  TABLET_S: 40,
  //640
  TABLET: 48,
  //768
  LAPTOP_S: 64,
  //1024
  LAPTOP: 90,
  //1440
  // other break points
  MOBILE_XS: 20,
  //320
  MOBILE_S: 22.5,
  //360
  MOBILE_M: 23.44,
  //375
  TABLET_M: 45,
  //720
  LAPTOP_M: 80,
  //1280
  MONITOR_M: 100,
  //1600
  MONITOR: 120 //1920

};
exports.breakPoints = breakPoints;

function getBreakPointValue(breakPoint) {
  return breakPoints[breakPoint] * (0, _getHTMLFontSize.getHTMLFontSize)(); // return breakPoints[breakPoint] * 16;
}

var sortedBreackPointKey = Object.keys(breakPoints).sort(function (a, b) {
  return breakPoints[a] - breakPoints[b];
});
exports.sortedBreackPointKey = sortedBreackPointKey;

function defaultMatcher(size) {
  var currentSize = '';

  if (!size) {
    return currentSize;
  }

  var key;

  for (var i = 0; i < sortedBreackPointKey.length; i++) {
    key = sortedBreackPointKey[i];

    if (getBreakPointValue(key) >= size.width) {
      break;
    }
  }

  return key;
}