"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tabs_propTypes = exports.Tab_propTypes = exports.TabWrapper_propTypes = exports.TabContent_propTypes = exports.TabContentWrapper_propTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Tab_propTypes = {
  activeClass: _propTypes["default"].string,
  align: _propTypes["default"].string,
  children: _propTypes["default"].oneOfType([_propTypes["default"].element, _propTypes["default"].string]),
  className: _propTypes["default"].string,
  dataId: _propTypes["default"].string,
  getTabRef: _propTypes["default"].func,
  href: _propTypes["default"].string,
  id: _propTypes["default"].string,
  isActive: _propTypes["default"].bool,
  isAnimate: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  isLink: _propTypes["default"].bool,
  needAppearance: _propTypes["default"].bool,
  needBorder: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  style: _propTypes["default"].object,
  text: _propTypes["default"].string,
  title: _propTypes["default"].string,
  titlePosition: _propTypes["default"].oneOf(['top', 'bottom', 'right', 'left']),
  tourId: _propTypes["default"].string,
  type: _propTypes["default"].string,
  customProps: _propTypes["default"].object,
  isVirtual: _propTypes["default"].bool,
  dataSelectorId: _propTypes["default"].string
};
exports.Tab_propTypes = Tab_propTypes;
var TabContent_propTypes = {
  children: _propTypes["default"].node,
  dataId: _propTypes["default"].string,
  id: _propTypes["default"].string,
  scroll: _propTypes["default"].oneOf(['vertical', 'horizontal', 'both', 'none']),
  dataSelectorId: _propTypes["default"].string
};
exports.TabContent_propTypes = TabContent_propTypes;
var TabContentWrapper_propTypes = {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  dataId: _propTypes["default"].string,
  onScroll: _propTypes["default"].func,
  selectedTab: _propTypes["default"].string,
  style: _propTypes["default"].object,
  dataSelectorId: _propTypes["default"].string
};
exports.TabContentWrapper_propTypes = TabContentWrapper_propTypes;
var Tabs_propTypes = {
  align: _propTypes["default"].oneOf(['vertical', 'horizontal']),
  boxPosition: _propTypes["default"].string,
  childType: _propTypes["default"].elementType,
  children: _propTypes["default"].array,
  className: _propTypes["default"].string,
  dataId: _propTypes["default"].string,
  getContainerRef: _propTypes["default"].func,
  highlightClass: _propTypes["default"].string,
  iconName: _propTypes["default"].string,
  iconSize: _propTypes["default"].string,
  isAnimate: _propTypes["default"].bool,
  isPopupOpen: _propTypes["default"].bool,
  isPopupReady: _propTypes["default"].bool,
  isResponsive: _propTypes["default"].bool,
  itemActiveClass: _propTypes["default"].string,
  itemClass: _propTypes["default"].string,
  maxTabsCount: _propTypes["default"].number,
  menuItemClass: _propTypes["default"].string,
  minTabsCount: _propTypes["default"].number,
  moreBoxClass: _propTypes["default"].string,
  moreButtonActiveClass: _propTypes["default"].string,
  moreButtonClass: _propTypes["default"].string,
  moreContainerClass: _propTypes["default"].string,
  needAppearance: _propTypes["default"].bool,
  needBorder: _propTypes["default"].bool,
  needPadding: _propTypes["default"].bool,
  needTabBorder: _propTypes["default"].bool,
  onScroll: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  position: _propTypes["default"].string,
  removeClose: _propTypes["default"].func,
  selectedTab: _propTypes["default"].string,
  showTitleInMoreOptions: _propTypes["default"].bool,
  style: _propTypes["default"].object,
  togglePopup: _propTypes["default"].func,
  type: _propTypes["default"].oneOf(['alpha', 'beta', 'delta']),
  getTargetRef: _propTypes["default"].func,
  containerClass: _propTypes["default"].string,
  customProps: _propTypes["default"].shape({
    DropBoxProps: _propTypes["default"].object,
    ListItemProps: _propTypes["default"].object,
    MoreButtonProps: _propTypes["default"].object
  }),
  getCustomDropBoxHeaderPlaceHolder: _propTypes["default"].func,
  dataSelectorId: _propTypes["default"].string
};
exports.Tabs_propTypes = Tabs_propTypes;
var TabWrapper_propTypes = {
  align: _propTypes["default"].oneOf(['vertical', 'horizontal']),
  children: _propTypes["default"].node,
  dataId: _propTypes["default"].string,
  defaultTab: _propTypes["default"].string,
  hookToDisableInternalState: _propTypes["default"].bool,
  isAnimate: _propTypes["default"].bool,
  needAppearance: _propTypes["default"].bool,
  needBorder: _propTypes["default"].bool,
  needPadding: _propTypes["default"].bool,
  needTabBorder: _propTypes["default"].bool,
  onSelect: _propTypes["default"].func,
  type: _propTypes["default"].oneOf(['alpha', 'beta', 'delta']),
  dataSelectorId: _propTypes["default"].string
};
exports.TabWrapper_propTypes = TabWrapper_propTypes;