"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

var _TextareaModule = _interopRequireDefault(require("./Textarea.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Textarea = /*#__PURE__*/function (_React$Component) {
  _inherits(Textarea, _React$Component);

  var _super = _createSuper(Textarea);

  function Textarea(props) {
    var _this;

    _classCallCheck(this, Textarea);

    _this = _super.call(this, props);
    _this.onChange = _this.onChange.bind(_assertThisInitialized(_this));
    _this.onKeyDown = _this.onKeyDown.bind(_assertThisInitialized(_this));
    _this.onBlur = _this.onBlur.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Textarea, [{
    key: "onChange",
    value: function onChange(e) {
      e && e.preventDefault();
      var onChange = this.props.onChange;
      onChange && onChange(e.target.value, e);
    }
  }, {
    key: "onBlur",
    value: function onBlur(e) {
      e && e.preventDefault();
      var onBlur = this.props.onBlur;
      onBlur && onBlur(e.target.value, e);
    }
  }, {
    key: "onKeyDown",
    value: function onKeyDown(e) {
      var onKeyDown = this.props.onKeyDown;
      onKeyDown && onKeyDown(e);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          size = _this$props.size,
          placeHolder = _this$props.placeHolder,
          needBorder = _this$props.needBorder,
          text = _this$props.text,
          isDisabled = _this$props.isDisabled,
          resize = _this$props.resize,
          maxLength = _this$props.maxLength,
          animated = _this$props.animated,
          variant = _this$props.variant,
          getRef = _this$props.getRef,
          onFocus = _this$props.onFocus,
          dataId = _this$props.dataId,
          dataSelectorId = _this$props.dataSelectorId,
          isReadOnly = _this$props.isReadOnly,
          needAppearance = _this$props.needAppearance,
          needReadOnlyStyle = _this$props.needReadOnlyStyle,
          borderColor = _this$props.borderColor,
          needEffect = _this$props.needEffect,
          autoFocus = _this$props.autoFocus,
          htmlId = _this$props.htmlId,
          a11y = _this$props.a11y,
          customClass = _this$props.customClass;
      var ariaLabel = a11y.ariaLabel,
          ariaLabelledby = a11y.ariaLabelledby;
      var resizes = {
        horizontal: 'resizeX',
        vertical: 'resizeY',
        both: 'resizeboth',
        none: 'noresize'
      };
      var options = {};

      if (isReadOnly) {
        options.readOnly = 'readOnly';
      }

      if (isDisabled) {
        options.disabled = 'disabled';
      }

      if (autoFocus) {
        options.autoFocus = true;
      }

      var classList = needAppearance ? "".concat(_TextareaModule["default"].container, " ").concat(_TextareaModule["default"][size], " ").concat(_TextareaModule["default"][variant], " ").concat(needBorder ? _TextareaModule["default"].needBorder : _TextareaModule["default"].noBorder, " ").concat(resize ? _TextareaModule["default"][resizes[resize]] : _TextareaModule["default"][resizes.none], "  ").concat(animated ? "".concat(_TextareaModule["default"]["".concat(size, "animated")]) : '', "   ").concat(isDisabled && !needEffect || isReadOnly && !needEffect ? '' : _TextareaModule["default"].effect) : "".concat(_TextareaModule["default"].basic);
      return /*#__PURE__*/_react["default"].createElement("textarea", _extends({
        "aria-label": ariaLabel,
        "aria-labelledby": ariaLabelledby,
        className: "".concat(customClass, " ").concat(isReadOnly && needReadOnlyStyle ? _TextareaModule["default"].readonly : '', " ").concat(classList, " ").concat(_TextareaModule["default"]["borderColor_".concat(borderColor)]),
        placeholder: placeHolder
      }, options, {
        "data-id": dataId,
        "data-test-id": dataId,
        maxLength: maxLength,
        onChange: this.onChange,
        onKeyDown: this.onKeyDown,
        onFocus: onFocus,
        onBlur: this.onBlur,
        ref: getRef,
        value: text,
        id: htmlId,
        "data-selector-id": dataSelectorId
      }));
    }
  }]);

  return Textarea;
}(_react["default"].Component);

exports["default"] = Textarea;
Textarea.defaultProps = _defaultProps.defaultProps;
Textarea.propTypes = _propTypes.propTypes; // if (__DOCS__) {
//   Textarea.docs = {
//     componentGroup: 'Form Elements',
//     folderName: 'Style Guide',
//     external: true,
//     description: ' '
//   };
// }