"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

var _velocityReact = require("velocity-react");

require("velocity-animate/velocity.ui");

var _LibraryContextInit = _interopRequireDefault(require("../../Provider/LibraryContextInit"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var VelocityAnimation = /*#__PURE__*/function (_React$Component) {
  _inherits(VelocityAnimation, _React$Component);

  var _super = _createSuper(VelocityAnimation);

  function VelocityAnimation(props) {
    _classCallCheck(this, VelocityAnimation);

    return _super.call(this, props);
  }

  _createClass(VelocityAnimation, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          name = _this$props.name,
          duration = _this$props.duration,
          isActive = _this$props.isActive,
          runOnMount = _this$props.runOnMount,
          delay = _this$props.delay,
          isCustomized = _this$props.isCustomized,
          needUIPack = _this$props.needUIPack,
          isFlex = _this$props.isFlex;

      var _ref = this.context || {},
          direction = _ref.direction,
          isReducedMotion = _ref.isReducedMotion;

      var enterAnimationObj = {
        fade: 'transition.fadeIn',
        slideDown: 'slideDown',
        flyDown: {
          translateY: '0%'
        },
        slideRight: {
          translateX: '0%'
        },
        slideLeft: {
          translateX: '0%'
        },
        shrink: 'transition.shrinkIn',
        expand: 'transition.expandIn'
      };
      var exitAnimationObj = {
        fade: 'transition.fadeOut',
        slideDown: 'slideUp',
        flyDown: {
          translateY: '-100%'
        },
        slideRight: {
          translateX: direction == 'rtl' ? '-100%' : '100%'
        },
        slideLeft: {
          translateX: direction == 'rtl' ? '100%' : '-100%'
        },
        shrink: 'transition.shrinkOut',
        expand: 'transition.expandOut'
      };
      var animation = isCustomized ? isActive ? enterAnimationObj[name] : exitAnimationObj[name] : needUIPack ? "transition.".concat(name).concat(isActive ? 'In' : 'Out') : name;
      return /*#__PURE__*/_react["default"].createElement(_velocityReact.VelocityComponent, {
        key: name,
        animation: animation,
        duration: !isReducedMotion ? duration : 0,
        runOnMount: runOnMount,
        display: isActive ? isFlex ? 'flex' : '' : 'none',
        delay: delay,
        interruptBehavior: "queue"
      }, children);
    }
  }]);

  return VelocityAnimation;
}(_react["default"].Component);

exports["default"] = VelocityAnimation;
VelocityAnimation.defaultProps = _defaultProps.defaultProps;
VelocityAnimation.propTypes = _propTypes.propTypes;
VelocityAnimation.contextType = _LibraryContextInit["default"]; // if (__DOCS__) {
//   VelocityAnimation.docs = {
//     componentGroup: 'Animation'
//   };
// }