"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

var _velocityReact = require("velocity-react");

require("velocity-animate/velocity.ui");

var _LibraryContextInit = _interopRequireDefault(require("../../Provider/LibraryContextInit"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function clearProps(props) {
  var newProps = Object.assign({}, props);
  Object.keys(VelocityAnimationGroup.propTypes).forEach(function (key) {
    delete newProps[key];
  });
  return newProps;
}

var VelocityAnimationGroup = /*#__PURE__*/function (_React$Component) {
  _inherits(VelocityAnimationGroup, _React$Component);

  var _super = _createSuper(VelocityAnimationGroup);

  function VelocityAnimationGroup(props) {
    _classCallCheck(this, VelocityAnimationGroup);

    return _super.call(this, props);
  }

  _createClass(VelocityAnimationGroup, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          enterName = _this$props.enterName,
          exitName = _this$props.exitName,
          enterDuration = _this$props.enterDuration,
          exitDuration = _this$props.exitDuration,
          isActive = _this$props.isActive,
          component = _this$props.component,
          runOnMount = _this$props.runOnMount,
          enterShowStyle = _this$props.enterShowStyle,
          enterHideStyle = _this$props.enterHideStyle,
          exitDelay = _this$props.exitDelay,
          isFlex = _this$props.isFlex,
          enterDelay = _this$props.enterDelay,
          isCustomized = _this$props.isCustomized,
          name = _this$props.name,
          needUIPack = _this$props.needUIPack;

      var _ref = this.context || {},
          direction = _ref.direction,
          isReducedMotion = _ref.isReducedMotion;

      var childProps = clearProps(this.props);
      var enterAnimationObj = {
        fade: 'transition.fadeIn',
        slideDown: 'slideDown',
        flyDown: {
          translateY: '0%'
        },
        slideRight: {
          translateX: '0%'
        },
        slideLeft: {
          translateX: '0%'
        },
        shrink: 'transition.shrinkIn',
        expand: 'transition.expandIn'
      };
      var exitAnimationObj = {
        fade: 'transition.fadeOut',
        slideDown: 'slideUp',
        flyDown: {
          translateY: '-100%'
        },
        slideRight: {
          translateX: direction == 'rtl' ? '-100%' : '100%'
        },
        slideLeft: {
          translateX: direction == 'rtl' ? '100%' : '-100%'
        },
        shrink: 'transition.shrinkOut',
        expand: 'transition.expandOut'
      };
      var enterAnimation = {
        animation: isCustomized ? enterAnimationObj[name] : needUIPack ? "transition.".concat(enterName, "In") : enterName,
        duration: !isReducedMotion ? enterDuration : 0,
        delay: enterDelay ? enterDelay : 0,
        display: isFlex ? 'flex' : ''
      };
      var exitAnimation = {
        animation: isCustomized ? exitAnimationObj[name] : needUIPack ? "transition.".concat(exitName ? exitName : enterName, "Out") : exitName ? exitName : enterName,
        duration: !isReducedMotion ? exitDuration : 0,
        delay: exitDelay ? exitDelay : 0,
        display: 'none'
      };
      return /*#__PURE__*/_react["default"].createElement(_velocityReact.VelocityTransitionGroup, _extends({
        enter: enterAnimation,
        leave: exitAnimation,
        component: component && component,
        runOnMount: runOnMount,
        enterHideStyle: enterHideStyle,
        enterShowStyle: enterShowStyle
      }, childProps), isActive ? children : null);
    }
  }]);

  return VelocityAnimationGroup;
}(_react["default"].Component);

exports["default"] = VelocityAnimationGroup;
VelocityAnimationGroup.defaultProps = _objectSpread(_objectSpread({}, _defaultProps.defaultProps), {}, {
  component: _react["default"].Fragment
});
VelocityAnimationGroup.propTypes = _propTypes.propTypes;
VelocityAnimationGroup.contextType = _LibraryContextInit["default"]; // if (__DOCS__) {
//   VelocityAnimationGroup.docs = {
//     componentGroup: 'Animation'
//   };
// }