"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.YearView_propTypes = exports.Time_propTypes = exports.Span_propTypes = exports.DaysRow_propTypes = exports.DateWidget_propTypes = exports.DateTime_propTypes = exports.DateTimePopupHeader_propTypes = exports.DateTimePopupFooter_propTypes = exports.CalendarView_propTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _dateFormats = require("../../../DateTime/dateFormatUtils/dateFormats");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var CalendarView_propTypes = {
  dataId: _propTypes["default"].string,
  date: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  month: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  needBorder: _propTypes["default"].bool,
  onSelect: _propTypes["default"].func,
  year: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  dayNames: _propTypes["default"].array,
  dayNamesShort: _propTypes["default"].array,
  todayMonth: _propTypes["default"].string,
  todayDate: _propTypes["default"].string,
  todayYear: _propTypes["default"].string,
  startDate: _propTypes["default"].string,
  endDate: _propTypes["default"].string
};
exports.CalendarView_propTypes = CalendarView_propTypes;
var Span_propTypes = {
  dataId: _propTypes["default"].string,
  handleSelect: _propTypes["default"].func,
  i: _propTypes["default"].number,
  incremday: _propTypes["default"].number,
  isActive: _propTypes["default"].bool,
  tdclass: _propTypes["default"].string,
  userSeeMonth: _propTypes["default"].number,
  userSeeYear: _propTypes["default"].number,
  isToday: _propTypes["default"].bool,
  startDate: _propTypes["default"].string,
  endDate: _propTypes["default"].string
};
exports.Span_propTypes = Span_propTypes;
var DateTime_propTypes = {
  boxSize: _propTypes["default"].string,
  className: _propTypes["default"].string,
  dataId: _propTypes["default"].string,
  dateFormat: _propTypes["default"].string,
  // eslint-disable-next-line react/no-unused-prop-types
  defaultTime: _propTypes["default"].string,
  getMethods: _propTypes["default"].func,
  getRef: _propTypes["default"].func,
  i18nKeys: _propTypes["default"].shape({
    timeText: _propTypes["default"].string.isRequired,
    submitText: _propTypes["default"].string.isRequired,
    cancelText: _propTypes["default"].string.isRequired,
    hourEmptyText: _propTypes["default"].string.isRequired,
    minuteEmptyText: _propTypes["default"].string.isRequired,
    nextMonthTitleText: _propTypes["default"].string.isRequired,
    prevMonthTitleText: _propTypes["default"].string.isRequired
  }),
  innerClass: _propTypes["default"].string,
  isAbsolute: _propTypes["default"].bool,
  isActive: _propTypes["default"].bool,
  isAnimate: _propTypes["default"].bool,
  isDateTimeField: _propTypes["default"].bool,
  isPadding: _propTypes["default"].bool,
  isReady: _propTypes["default"].bool,
  max: _propTypes["default"].string,
  maxErrorText: _propTypes["default"].string,
  min: _propTypes["default"].string,
  minErrorText: _propTypes["default"].string,
  // eslint-disable-next-line react/no-unused-prop-types
  needAction: _propTypes["default"].bool,
  needDefaultTime: _propTypes["default"].bool,
  needResponsive: _propTypes["default"].bool,
  onChange: _propTypes["default"].func,
  onClear: _propTypes["default"].func,
  onClick: _propTypes["default"].func,
  onDateSelect: _propTypes["default"].func,
  onError: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  position: _propTypes["default"].string,
  timeZone: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  is24Hour: _propTypes["default"].bool,
  isDefaultPosition: _propTypes["default"].bool,
  customDateFormat: _propTypes["default"].string,
  positionsOffset: _propTypes["default"].array,
  targetOffset: _propTypes["default"].string,
  isRestrictScroll: _propTypes["default"].bool,
  dropBoxPortalId: _propTypes["default"].string,
  startDate: _propTypes["default"].string,
  endDate: _propTypes["default"].string
};
exports.DateTime_propTypes = DateTime_propTypes;
var DateWidget_propTypes = {
  borderColor: _propTypes["default"].oneOf(['transparent', 'default']),
  cantEditOnPopupOpen: _propTypes["default"].bool,
  children: _propTypes["default"].object,
  className: _propTypes["default"].string,
  closePopupOnly: _propTypes["default"].func,
  dataId: _propTypes["default"].string,
  dateFormat: _propTypes["default"].oneOf(_toConsumableArray(_dateFormats.dataFormatList)),
  defaultPosition: _propTypes["default"].oneOf(['top', 'bottom', 'right', 'left']),
  defaultTime: _propTypes["default"].string,
  getContainerRef: _propTypes["default"].func,
  getMethods: _propTypes["default"].func,
  getRef: _propTypes["default"].func,
  getTargetRef: _propTypes["default"].func,
  i18nKeys: _propTypes["default"].object,
  id: _propTypes["default"].string,
  isDateTime: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  isEditable: _propTypes["default"].bool,
  isPopupCloseOnClick: _propTypes["default"].bool,
  isPopupOpen: _propTypes["default"].bool,
  isPopupOpenOnClick: _propTypes["default"].bool,
  isPopupOpenOnEnter: _propTypes["default"].bool,
  isPopupReady: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  max: _propTypes["default"].string,
  maxErrorText: _propTypes["default"].string,
  min: _propTypes["default"].string,
  minErrorText: _propTypes["default"].string,
  needBorder: _propTypes["default"].bool,
  needDefaultTime: _propTypes["default"].bool,
  needErrorOnBlur: _propTypes["default"].bool,
  needResponsive: _propTypes["default"].bool,
  onFailValidation: _propTypes["default"].func,
  onKeyDown: _propTypes["default"].func,
  onPassValidation: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  placeholder: _propTypes["default"].string,
  position: _propTypes["default"].string,
  removeClose: _propTypes["default"].func,
  textBoxSize: _propTypes["default"].string,
  textBoxVariant: _propTypes["default"].string,
  timeZone: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  togglePopup: _propTypes["default"].func,
  validation: _propTypes["default"].shape({
    validate: _propTypes["default"].bool,
    validateOn: _propTypes["default"].string,
    rulesOrder: _propTypes["default"].arrayOf(_propTypes["default"].string),
    rules: _propTypes["default"].object,
    messages: _propTypes["default"].object
  }),
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  htmlId: _propTypes["default"].string,
  iconOnHover: _propTypes["default"].bool,
  is24Hour: _propTypes["default"].bool,
  isHideCurrentYear: _propTypes["default"].bool,
  onFocus: _propTypes["default"].func,
  onBlur: _propTypes["default"].func,
  boxSize: _propTypes["default"].string,
  onError: _propTypes["default"].func,
  isAbsolutePositioningNeeded: _propTypes["default"].bool,
  positionsOffset: _propTypes["default"].array,
  targetOffset: _propTypes["default"].array,
  isRestrictScroll: _propTypes["default"].bool,
  dropBoxPortalId: _propTypes["default"].string,
  a11y: _propTypes["default"].object,
  startDate: _propTypes["default"].string,
  endDate: _propTypes["default"].string
};
exports.DateWidget_propTypes = DateWidget_propTypes;
var YearView_propTypes = {
  onSelectMonth: _propTypes["default"].func,
  onSelectYear: _propTypes["default"].func,
  viewedYear: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  viewedMonth: _propTypes["default"].string,
  monthNamesShort: _propTypes["default"].array,
  isMonthOpen: _propTypes["default"].bool
};
exports.YearView_propTypes = YearView_propTypes;
var DateTimePopupFooter_propTypes = {
  submitText: _propTypes["default"].string,
  onSubmit: _propTypes["default"].func,
  cancelText: _propTypes["default"].string,
  onCancel: _propTypes["default"].func,
  dataId: _propTypes["default"].string
};
exports.DateTimePopupFooter_propTypes = DateTimePopupFooter_propTypes;
var DateTimePopupHeader_propTypes = {
  onOpenYearView: _propTypes["default"].func,
  showMonthTxt: _propTypes["default"].string,
  isYearView: _propTypes["default"].bool,
  prevMonthTitleText: _propTypes["default"].string,
  nextMonthTitleText: _propTypes["default"].string,
  onModifyCalendar: _propTypes["default"].func
};
exports.DateTimePopupHeader_propTypes = DateTimePopupHeader_propTypes;
var DaysRow_propTypes = {
  dayNames: _propTypes["default"].array,
  dayNamesShort: _propTypes["default"].object
};
exports.DaysRow_propTypes = DaysRow_propTypes;
var Time_propTypes = {
  timeText: _propTypes["default"].string,
  dataId: _propTypes["default"].string,
  hourSuggestions: _propTypes["default"].array,
  onHourSelect: _propTypes["default"].func,
  hours: _propTypes["default"].string,
  hourEmptyText: _propTypes["default"].string,
  needResponsive: _propTypes["default"].bool,
  minSuggestions: _propTypes["default"].array,
  onMinutesSelect: _propTypes["default"].func,
  mins: _propTypes["default"].string,
  minuteEmptyText: _propTypes["default"].string,
  ampmSuggestions: _propTypes["default"].array,
  onAmPmSelect: _propTypes["default"].func,
  amPm: _propTypes["default"].string,
  is24Hour: _propTypes["default"].bool
};
exports.Time_propTypes = Time_propTypes;