"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DropDownContainer = DropDownContainer;
exports.DropDownItemContainer = DropDownItemContainer;
exports.DropDownTarget = DropDownTarget;
exports["default"] = DropDown;

var _react = _interopRequireDefault(require("react"));

var _propTypes = require("../../DropDown/props/propTypes");

var _defaultProps = require("../../DropDown/props/defaultProps");

var _DropDownModule = _interopRequireDefault(require("../../DropDown/DropDown.module.css"));

var _PopOver = _interopRequireWildcard(require("../PopOver/PopOver"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function DropDown(props) {
  var children = props.children;
  return /*#__PURE__*/_react["default"].createElement(_PopOver["default"], props, /*#__PURE__*/_react["default"].createElement(_PopOver.PopOverTarget, null, children[0]), /*#__PURE__*/_react["default"].createElement(_PopOver.PopOverContainer, null, children[1]));
}

DropDown.propTypes = _propTypes.DropDown_propTypes;

function DropDownTarget(props) {
  var children = props.children;
  return /*#__PURE__*/_react["default"].createElement("div", null, children);
}

DropDownTarget.propTypes = _propTypes.DropDownTarget_propTypes;

function DropDownContainer(props) {
  var children = props.children;
  return /*#__PURE__*/_react["default"].createElement("div", null, " ", children, " ");
}

DropDownContainer.propTypes = _propTypes.DropDownContainer_propTypes;

function DropDownItemContainer(props) {
  var children = props.children,
      dataId = props.dataId,
      getRef = props.getRef,
      onScroll = props.onScroll;

  function handleScroll(e) {
    onScroll && onScroll(e);
  }

  function getReference(ele) {
    getRef && getRef(ele);
  }

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _DropDownModule["default"].listGroup,
    onScroll: handleScroll,
    ref: getReference,
    "data-id": dataId,
    "data-test-id": dataId
  }, children);
}

DropDownItemContainer.propTypes = _propTypes.DropDownItemContainer_propTypes;
DropDownItemContainer.defaultProps = _defaultProps.DropDownItemContainer_defaultProps;