"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Layout = require("../Layout");

var _CssProvider = _interopRequireDefault(require("../../Provider/CssProvider"));

var _ListItemModule = _interopRequireDefault(require("../../ListItem/ListItem.module.css"));

var _defaultProps = require("../../ListItem/props/defaultProps");

var _propTypes = require("../../ListItem/props/propTypes");

var _CustomResponsive = require("../Responsive/CustomResponsive");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var ListContainer = function ListContainer(props) {
  var size = props.size,
      active = props.active,
      highlight = props.highlight,
      autoHover = props.autoHover,
      palette = props.palette,
      title = props.title,
      disableTitle = props.disableTitle,
      needTick = props.needTick,
      isLink = props.isLink,
      href = props.href,
      target = props.target,
      needBorder = props.needBorder,
      isDisabled = props.isDisabled,
      children = props.children,
      dataId = props.dataId,
      dataSelectorId = props.dataSelectorId,
      a11y = props.a11y,
      customClass = props.customClass,
      customProps = props.customProps,
      onClick = props.onClick,
      onMouseEnter = props.onMouseEnter,
      onMouseOver = props.onMouseOver,
      eleRef = props.eleRef;
  var responsiveFunc = (0, _react.useCallback)(function (_ref) {
    var mediaQueryOR = _ref.mediaQueryOR,
        isTouchDevice = _ref.isTouchDevice;
    return {
      mobileToTab: mediaQueryOR([{
        maxWidth: 700
      }]),
      isTouchDevice: isTouchDevice
    };
  }, []);

  var _useResponsiveReceive = (0, _CustomResponsive.useResponsiveReceiver)('Helmet', responsiveFunc),
      mobileToTab = _useResponsiveReceive.mobileToTab,
      isTouchDevice = _useResponsiveReceive.isTouchDevice;

  var role = a11y.role,
      ariaSelected = a11y.ariaSelected,
      ariaLabel = a11y.ariaLabel,
      _a11y$insetFocus = a11y.insetFocus,
      insetFocus = _a11y$insetFocus === void 0 ? true : _a11y$insetFocus;
  var options = {};

  if (isLink) {
    options.href = href;
    options.target = "_".concat(target);
  }

  if (active) {
    options['data-selected'] = active;
  }

  if (!isDisabled && !isLink) {
    options.tabindex = '0';
  }

  return /*#__PURE__*/_react["default"].createElement(_Layout.Container, _extends({
    role: role,
    "data-a11y-inset-focus": insetFocus,
    "aria-selected": ariaSelected,
    "aria-label": ariaLabel,
    isCover: false,
    align: "vertical",
    alignBox: "row",
    className: "".concat(_ListItemModule["default"].list, " ").concat(_ListItemModule["default"][size], " ").concat(mobileToTab && isTouchDevice ? _ListItemModule["default"].responsiveHeight : '', " ").concat(_ListItemModule["default"][palette], " ").concat(active ? _ListItemModule["default"]["active".concat(palette)] : highlight && !isDisabled ? _ListItemModule["default"]["".concat(palette, "Hover")] : '', " ").concat(autoHover && !isDisabled ? _ListItemModule["default"]["".concat(palette, "Effect")] : '', " ").concat(needTick ? _ListItemModule["default"]["".concat(size, "withTick")] : '', " ").concat(isDisabled ? (0, _CssProvider["default"])('isDisable') : '', " ").concat(needBorder ? active ? _ListItemModule["default"].activewithBorder : _ListItemModule["default"].withBorder : '', " ").concat(customClass),
    dataId: dataId,
    dataSelectorId: dataSelectorId,
    onClick: !isDisabled && onClick,
    onMouseEnter: onMouseEnter,
    onMouseOver: onMouseOver,
    eleRef: eleRef,
    tagName: isLink ? 'a' : 'li',
    "data-title": isDisabled ? disableTitle : title
  }, options, customProps), children);
};

ListContainer.defaultProps = _defaultProps.ListContainerDefaultProps;
ListContainer.propTypes = _propTypes.ListContainer_Props;
var _default = ListContainer; // if (__DOCS__) {
//   ListContainer.docs = {
//     componentGroup: 'Molecule',
//     folderName: 'Style Guide'
//   };
// }

exports["default"] = _default;