"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ResponsiveDropBox;

var _react = _interopRequireWildcard(require("react"));

var _defaultProps = require("../../ResponsiveDropBox/props/defaultProps");

var _propTypes = require("../../ResponsiveDropBox/props/propTypes");

var _DropBox = _interopRequireDefault(require("../DropBox/DropBox"));

var _Layout = require("../Layout");

var _CustomResponsive = require("../Responsive/CustomResponsive");

var _ResponsiveDropBoxModule = _interopRequireDefault(require("../../ResponsiveDropBox/ResponsiveDropBox.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ResponsiveDropBox(props) {
  var children = props.children,
      _props$customClass = props.customClass,
      customClass = _props$customClass === void 0 ? {} : _props$customClass,
      isResponsivePadding = props.isResponsivePadding,
      alignBox = props.alignBox;
  var _customClass$customDr = customClass.customDropBox,
      customDropBox = _customClass$customDr === void 0 ? '' : _customClass$customDr,
      _customClass$customMo = customClass.customMobileDropBox,
      customMobileDropBox = _customClass$customMo === void 0 ? '' : _customClass$customMo,
      _customClass$customDr2 = customClass.customDropBoxWrap,
      customDropBoxWrap = _customClass$customDr2 === void 0 ? '' : _customClass$customDr2,
      _customClass$customMo2 = customClass.customMobileDropBoxWrap,
      customMobileDropBoxWrap = _customClass$customMo2 === void 0 ? '' : _customClass$customMo2,
      _customClass$customRe = customClass.customResponsiveContainer,
      customResponsiveContainer = _customClass$customRe === void 0 ? '' : _customClass$customRe;
  var dropBoxClasses = {
    customDropBox: "".concat(customDropBox),
    customMobileDropBox: "".concat(customMobileDropBox),
    customDropBoxWrap: "".concat(customDropBoxWrap),
    customMobileDropBoxWrap: "".concat(customMobileDropBoxWrap),
    customResponsiveContainer: "".concat(customResponsiveContainer)
  };
  var responsiveFunc = (0, _react.useCallback)(function (_ref) {
    var mediaQueryOR = _ref.mediaQueryOR;
    return {
      tabletMode: mediaQueryOR([{
        maxWidth: 700
      }])
    };
  }, []);
  return /*#__PURE__*/_react["default"].createElement(_DropBox["default"], _extends({}, props, {
    customClass: dropBoxClasses
  }), /*#__PURE__*/_react["default"].createElement(_CustomResponsive.ResponsiveReceiver, {
    query: responsiveFunc,
    responsiveId: "Helmet"
  }, function (_ref2) {
    var tabletMode = _ref2.tabletMode;
    return /*#__PURE__*/_react["default"].createElement(_Layout.Container, {
      alignBox: alignBox,
      isCover: false,
      className: "".concat(tabletMode ? _ResponsiveDropBoxModule["default"].dropBoxContainer : '', " ").concat(tabletMode && isResponsivePadding ? _ResponsiveDropBoxModule["default"].boxPadding : '', " ").concat(customResponsiveContainer)
    }, children);
  }));
}

ResponsiveDropBox.propTypes = _propTypes.propTypes;
ResponsiveDropBox.defaultProps = _defaultProps.defaultProps;