"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

var _cssJSLogic2 = _interopRequireDefault(require("./css/cssJSLogic"));

var _utils = require("@zohodesk/utils");

var _TypographyModule = _interopRequireDefault(require("./css/Typography.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Typography = function Typography(props) {
  var children = props.children,
      $ui_tagName = props.$ui_tagName,
      $i18n_dataTitle = props.$i18n_dataTitle,
      testId = props.testId,
      customId = props.customId,
      $tagAttributes_text = props.$tagAttributes_text,
      $a11yAttributes_text = props.$a11yAttributes_text,
      customStyle = props.customStyle;
  var style = (0, _utils.mergeStyle)(_TypographyModule["default"], customStyle);

  var _cssJSLogic = (0, _cssJSLogic2["default"])({
    props: props,
    style: style
  }),
      typographyClass = _cssJSLogic.typographyClass;

  return /*#__PURE__*/_react["default"].createElement($ui_tagName, _objectSpread(_objectSpread({
    className: typographyClass,
    'data-title': $i18n_dataTitle,
    'data-id': customId,
    'data-test-id': testId
  }, $tagAttributes_text), $a11yAttributes_text), children);
};

Typography.propTypes = _propTypes.propTypes;
Typography.defaultProps = _defaultProps.defaultProps;
var _default = Typography;
exports["default"] = _default;