"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = cssJSLogic;

var _utils = require("@zohodesk/utils");

var _letterSpacingMap = require("./letterSpacingMap");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function cssJSLogic(_ref) {
  var _compileClassNames;

  var props = _ref.props,
      style = _ref.style;
  var $flag_reset = props.$flag_reset,
      $flag_dotted = props.$flag_dotted,
      $ui_size = props.$ui_size,
      $ui_lineClamp = props.$ui_lineClamp,
      $ui_lineHeight = props.$ui_lineHeight,
      $ui_display = props.$ui_display,
      $ui_weight = props.$ui_weight,
      $ui_typeFace = props.$ui_typeFace,
      $ui_textAlign = props.$ui_textAlign,
      $ui_letterSpacing = props.$ui_letterSpacing,
      $ui_transform = props.$ui_transform,
      $ui_decoration = props.$ui_decoration,
      $ui_className = props.$ui_className,
      $ui_wordBreak = props.$ui_wordBreak,
      $ui_wordWrap = props.$ui_wordWrap,
      $ui_whiteSpace = props.$ui_whiteSpace;

  if ($ui_letterSpacing && $ui_letterSpacing.match(/\./g)) {
    $ui_letterSpacing = _letterSpacingMap.letterspacingMapping[$ui_letterSpacing];
  }

  var typographyClass = (0, _utils.compileClassNames)((_compileClassNames = {}, _defineProperty(_compileClassNames, style.reset, $flag_reset), _defineProperty(_compileClassNames, style.dotted, $flag_dotted), _defineProperty(_compileClassNames, style["size".concat($ui_size)], !!$ui_size), _defineProperty(_compileClassNames, style["lineclamp_".concat($ui_lineClamp)], !!$ui_lineClamp), _defineProperty(_compileClassNames, style["lineheight_".concat($ui_lineHeight)], !!$ui_lineHeight), _defineProperty(_compileClassNames, style["display_".concat($ui_display)], !!$ui_display), _defineProperty(_compileClassNames, style["font_".concat($ui_weight)], !!$ui_weight), _defineProperty(_compileClassNames, style["fontStyles_".concat($ui_typeFace)], !!$ui_typeFace), _defineProperty(_compileClassNames, style["textalign_".concat($ui_textAlign)], !!$ui_textAlign), _defineProperty(_compileClassNames, style["letterspacing_".concat($ui_letterSpacing)], !!$ui_letterSpacing), _defineProperty(_compileClassNames, style["transform_".concat($ui_transform)], !!$ui_transform), _defineProperty(_compileClassNames, style["decoration_".concat($ui_decoration)], !!$ui_decoration), _defineProperty(_compileClassNames, $ui_className, !!$ui_className), _defineProperty(_compileClassNames, style["wordBreak_".concat($ui_wordBreak)], !!$ui_wordBreak), _defineProperty(_compileClassNames, style["wordWrap_".concat($ui_wordWrap)], !!$ui_wordWrap), _defineProperty(_compileClassNames, style["whiteSpace_".concat($ui_whiteSpace)], !!$ui_whiteSpace), _compileClassNames));
  return {
    typographyClass: typographyClass
  };
}