"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = VelocityAnimation;

var _react = _interopRequireWildcard(require("react"));

var _defaultProps = require("../../../VelocityAnimation/VelocityAnimation/props/defaultProps");

var _propTypes = require("../../../VelocityAnimation/VelocityAnimation/props/propTypes");

var _velocityReact = require("velocity-react");

require("velocity-animate/velocity.ui");

var _LibraryContextInit = _interopRequireDefault(require("../../../Provider/LibraryContextInit"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function VelocityAnimation(props) {
  var children = props.children,
      name = props.name,
      duration = props.duration,
      isActive = props.isActive,
      runOnMount = props.runOnMount,
      delay = props.delay,
      isCustomized = props.isCustomized,
      needUIPack = props.needUIPack,
      isFlex = props.isFlex;

  var _ref = (0, _react.useContext)(_LibraryContextInit["default"]) || {},
      direction = _ref.direction,
      isReducedMotion = _ref.isReducedMotion;

  var enterAnimationObj = {
    fade: 'transition.fadeIn',
    slideDown: 'slideDown',
    flyDown: {
      translateY: '0%'
    },
    slideRight: {
      translateX: '0%'
    },
    slideLeft: {
      translateX: '0%'
    },
    shrink: 'transition.shrinkIn',
    expand: 'transition.expandIn'
  };
  var exitAnimationObj = {
    fade: 'transition.fadeOut',
    slideDown: 'slideUp',
    flyDown: {
      translateY: '-100%'
    },
    slideRight: {
      translateX: direction == 'rtl' ? '-100%' : '100%'
    },
    slideLeft: {
      translateX: direction == 'rtl' ? '100%' : '-100%'
    },
    shrink: 'transition.shrinkOut',
    expand: 'transition.expandOut'
  };
  var animation = isCustomized ? isActive ? enterAnimationObj[name] : exitAnimationObj[name] : needUIPack ? "transition.".concat(name).concat(isActive ? 'In' : 'Out') : name;
  return /*#__PURE__*/_react["default"].createElement(_velocityReact.VelocityComponent, {
    key: name,
    animation: animation,
    duration: !isReducedMotion ? duration : 0,
    runOnMount: runOnMount,
    display: isActive ? isFlex ? 'flex' : '' : 'none',
    delay: delay,
    interruptBehavior: "queue"
  }, children);
}

VelocityAnimation.defaultProps = _defaultProps.defaultProps;
VelocityAnimation.propTypes = _propTypes.propTypes; // if (__DOCS__) {
//   VelocityAnimation.docs = {
//     componentGroup: 'Animation'
//   };
// }